﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace CustomPieChart
{
    public class PieSample : ContentPage
    {
        ObservableCollection<ChartDataPoint> datas, newData;
        SfChart chart;
        StackLayout stackLayout;
        public PieSample()
        {
            datas = new ObservableCollection<ChartDataPoint>();
            newData = new ObservableCollection<ChartDataPoint>();

            chart = new SfChart();
            chart.VerticalOptions = LayoutOptions.FillAndExpand;
            chart.Legend = new ChartLegend();

            stackLayout = new StackLayout();
            stackLayout.VerticalOptions = LayoutOptions.FillAndExpand;

            datas.Add(new ChartDataPoint("Knut", 25.5));
            datas.Add(new ChartDataPoint("Aron", 55));
            datas.Add(new ChartDataPoint("Tiny", 30.6));
            datas.Add(new ChartDataPoint("Erik", 75));
            datas.Add(new ChartDataPoint("Eriks", 60.3));
            datas.Add(new ChartDataPoint("Extrahjelp", 50.5));
            datas.Add(new ChartDataPoint("Helle", 55.8));
            datas.Add(new ChartDataPoint("Karl Peter", 30.4));
            datas.Add(new ChartDataPoint("Francis", 75.3));
            datas.Add(new ChartDataPoint("Camille", 60));

            IList<ChartDataPoint> sortedDatas = datas.OrderByDescending(item => item.YValue).ToList();

            IList<ChartDataPoint> afterFiveItems = sortedDatas.Where(item => sortedDatas.IndexOf(item) >= 5).ToList();
            IList<ChartDataPoint> beforeFiveItems = sortedDatas.Where(item => sortedDatas.IndexOf(item) < 5).ToList();

            beforeFiveItems.Add(new ChartDataPoint("Others", afterFiveItems.Sum(item => item.YValue)));

            PieSeries pieSeries = new PieSeries();
            pieSeries.DataMarker = new ChartDataMarker();  
            pieSeries.DataMarker.ShowLabel = true;
            pieSeries.DataMarker.LabelStyle.LabelPosition = DataMarkerLabelPosition.Center;
            pieSeries.ItemsSource = beforeFiveItems;
            chart.Series.Add(pieSeries);

            stackLayout.Children.Add(chart);
            Content = stackLayout;
        }
    }
}
